<?php
/**
 * Single Product Meta
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/single-product/meta.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.woocommerce.com/document/template-structure/
 * @author 		WooThemes
 * @package 	WooCommerce/Templates
 * @version     3.0.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

global $product;
?>
<div class="product_meta">

	<?php do_action( 'woocommerce_product_meta_start' ); ?>
	
	<?php $productmeta=emallshop_get_option('show-specific-productmeta', array('brand','sku','cats','tags')); //EmallShop ?>
	
	<?php if ( wc_product_sku_enabled() && ( $product->get_sku() || $product->is_type( 'variable' ) ) && ( !empty($productmeta) && in_array('sku', $productmeta) ) ) : ?>

		<span class="sku_wrapper"><?php esc_html_e( 'SKU:', 'emallshop' ); ?> <span class="sku"><?php echo esc_html( $sku = $product->get_sku() ) ? $sku : esc_html__( 'N/A', 'emallshop' ); ?></span></span>

	<?php endif; ?>

	<?php if(!empty($productmeta) && in_array('cats', $productmeta ) ) : ?>
	
		<?php echo wc_get_product_category_list( $product->get_id(), ', ', '<span class="posted_in">' . _n( 'Category:', 'Categories:', count( $product->get_category_ids() ), 'emallshop' ) . ' ', '</span>' ); ?>
		
	<?php endif; ?>

	<?php if(!empty($productmeta) && in_array('tags',  $productmeta ) ) : ?>
	
		<?php echo wc_get_product_tag_list( $product->get_id(), ', ', '<span class="tagged_as">' . _n( 'Tag:', 'Tags:', count( $product->get_tag_ids() ), 'emallshop' ) . ' ', '</span>' ); ?>
		
	<?php endif; ?>

	<?php do_action( 'woocommerce_product_meta_end' ); ?>

</div>
